// a rectangle that bounces around the screen,
// uses simple physics & edge detection
//
// Dan Wilcox 2015 danomatika.com
// EDPX 4010 Tools @ DU

// vectors contain an x, y, & z value
PVector pos; // current position
PVector vel; // current velocity

void setup() {
  size(400, 400);
  
  // create and set default vals
  pos = new PVector(width/2, height/2);
  vel = new PVector(2, -3);
  
  rectMode(CENTER);
  frameRate(60);
}

void draw() {
  background(200);
  
  // move the position each frame
  pos.add(vel); // pos = pos + vel
  
  // simple edge collision detection
  if(pos.x < 0 || pos.x > width) { // horz edges
    vel.x = -vel.x; // turn around 
  }
  if(pos.y < 0 || pos.y > height) { // vert edges
    vel.y = -vel.y; // turn around
  }
  
  // draw the rect
  rect(pos.x, pos.y, 20, 20);
}

// reset current pos to the mouse pos and choose
// a random vel
void mousePressed() {
  pos.x = mouseX;
  pos.y = mouseY;
  vel.x = random(-2, 2);
  vel.y = random(-3, 3);
}